{$R-,Q-,S-,Q-}
uses Crt;                                  { for keypressed only }

{$i pal_rad.src}

var BiosTicks: longint absolute $0040:$006C;

  const fading:integer=4;

{---------------- Stuff not specific to snowfall ----------------}
procedure VIDMode(Mode : Byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

var Scr: array[0..199,0..319] of byte absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;
var Scr2: TScr2 absolute $A000:$0000;
var Scr3, Scr4: ^TScr2;

function longmul(X, Y: Integer): Longint;
inline($5A/$58/$f7/$EA);

function LongDiv(X: Longint; Y: Integer): Integer;
inline($59/$58/$5A/$F7/$F9);

const color:byte=1;
procedure line(x1,y1,x2,y2:integer);
var i,j:integer;
    yy,xx:integer;
begin
  i := abs(x2-x1);
  j := abs(y2-y1);
  if i<j then i:=j;
  if i=0 then exit;

  for j := 0 to i do begin
    inc(scr[y1+longdiv(longmul(y2-y1,j), i),
            x1+longdiv(longmul(x2-x1,j), i)], color);{}
  end;
end;

procedure fcircle(x,y,r:integer);
var i,j:integer;
    s:longint;
begin
  for i:=y-r to y+r do begin
    for j := x-r to x+r do begin
      s:=longmul(j-x,j-x)+longmul(i-y,i-y)-longmul(r,r);
      if (s<-r) and (j>=0)and(j<320)and(i>=0)and(i<200) then
        Inc(Scr[I,J],Color);{}
{        Scr[I,J] := Color;{}
    end;
  end;
end;

procedure FEllipse(X,Y,AX,AY:Integer);
var I,J:Integer;
    s:longint;
begin
  for I:=Y-AY to Y+AY do begin
    for J := X-AX to X+AX do begin
{      S:=LongMul(J-X,J-X)*LongMul(AY,AY)
        +LongMul(I-Y,I-Y)*LongMul(AX,AX)
        -LongMul(AX,AX)*LongMul(AY,AY);
      if (S<-LongMul(AX,AY)) and (J>=0)and(J<320)and(I>=0)and(I<200) then
{        Inc(Scr[I,J],Color);{}
        Scr[I,J] := Color*(Abs(I-Y)+Abs(J-X)) ;{}
    end;
  end;
end;

procedure wash(var source, dest); assembler;
label m1, m2;
asm
  push ds
  push es

  mov  dx, fading
  xor  dh,dh
  mov  ds, word ptr [dest+2]
  mov  es, word ptr [source+2]
  xor  si,si
  xor  di,di

  xor  bx,bx

m1:
  xor  ah,ah
(**)
  mov  al,[es:si]
  shl  ax,2
  mov  bl,[es:si+1]
  add  ax,bx
  mov  bl,[es:si-1]
  add  ax,bx
  mov  bl,[es:si+320]
  add  ax,bx
  mov  bl,[es:si-320]
  add  ax,bx
  shr  ax,3
  mov  [ds:di],al
  sub  al, dl
  jb   m2
  mov  [ds:di],al
m2:
  dec  di
  dec  si
  jnz  m1

  pop  es
  pop  ds
end;

procedure movs(var source, dest); assembler;
asm
  push ds
  push es
  mov  es, word ptr [dest+2]
  mov  ds, word ptr [source+2]
  xor  si,si
  xor  di,di
  mov  cx, $4000
  cld
  db $66     { \\\           }
  rep  movsw { /// rep movsd }
  pop  es
  pop  ds
end;

function PixelOk(x,y,r:integer):boolean;
begin
  PixelOk := (x-r>=0)and(x+r<320)and(y-r>=0)and(y+r<200);
end;

{---------------------------MAIN PROGRAM-------------------------}

var
  CurFLAKE : Integer;                        { snowflake counter }
  I : Longint;                       { to add velocity to flakes }
  j: word;
  x,y,v,r,vx,vy,vr: integer;
  label M1,M2,MExit;
const XSize=36;
      YSize=30;
BEGIN
  randomize;

  vidMode($13);                       { 320x200x256 graphics mode }

  SetPalette;

  GetMem(Scr3,65535);
  GetMem(Scr4,65535);
  FillChar(Scr4^,65535,#0);

  X := 160; Y:=100;
  R:=15; VX:=0; VY:=0;
  repeat

    while (Port[$3DA] and $08) = $08 do;  { wait for vRetrace to }
    while (Port[$3DA] and $08) = $00 do;  { start and end        }

    Color:=0;
    FEllipse(X,Y,XSize+R,YSize-R);

    Inc(I);

    Color:=9;
    X:=160{10+XSize+Abs(I mod((300-XSize*2)*2) - (300-XSize*2))};
    Y:=160-(I mod 200)*(199- I mod 200) div 80;
    R:=Round((199-I mod 200)*Cos(I*PI/10)/20);
    FEllipse(X,Y,XSize+R,YSize-R);

    if KeyPressed then case ReadKey of
      #27: goto MExit;
    end;
  until False;
  MExit:

  vidMode($03);                       { return to 80x25 textmode }
end.

